// Guide3D / easyGuide Template V21

// JSLint directives
/*jslint browser: true */

// JSLint globals
/*global window, $, swfobject */

var oGuide;

$(function () {
    "use strict";

    var nScaling;

    oGuide = {
        "nProject": 100078,
        "sType": "EasyGuide",  // or Guide3D or EasyGuide; respect upper and lower case (e.g. not "easyGuide")
        "sMedia": "kiosk",  // or kiosk or web; respect upper and lower case (e.g. not "Kiosk")
        "oDocument": {
            "nWidth": $(window.document.body).width(),
            "nHeight": $(window.document.body).height()
        },
        "oApplicationNative": {
            "nWidth": 1080,
            "nHeight": 1920
        },
        "oOverlayNative": {
            "nLeft": 140,
            "nTop": 560,
            "nWidth": 800,
            "nHeight": 660
        },
        "nAutoReloadTimeoutId": window.setTimeout(function () { window.document.location.reload(true); }, 60 * 1000),
        "suppressAutoReload": function (nNextAutoReloadDelay) {
            window.clearTimeout(oGuide.nAutoReloadTimeoutId);
            if ($.isNumeric(nNextAutoReloadDelay)) {
                oGuide.nAutoReloadTimeoutId = window.setTimeout(function () {
                    window.document.location.reload(true);
                }, nNextAutoReloadDelay * 1000);
            }
            return true;
        },
        "displayOverlay": function (sUrl, nLeft, nTop, nWidth, nHeight) {
            if (sUrl) {
                $("iframe#iframeOverlay").attr("src", sUrl);
                oGuide.oOverlayCurrent.nLeft = $.isNumeric(nLeft)
                    ? Math.floor(nScaling * nLeft)
                    : oGuide.oOverlayCurrent.nLeft;
                oGuide.oOverlayCurrent.nTop = $.isNumeric(nTop)
                    ? Math.floor(nScaling * nTop)
                    : oGuide.oOverlayCurrent.nTop;
                oGuide.oOverlayCurrent.nWidth = $.isNumeric(nWidth)
                    ? Math.floor(nScaling * nWidth)
                    : oGuide.oOverlayCurrent.nWidth;
                oGuide.oOverlayCurrent.nHeight = $.isNumeric(nHeight)
                    ? Math.floor(nScaling * nHeight)
                    : oGuide.oOverlayCurrent.nHeight;
                $("div#divOverlay").css({
                    "display": "block",
                    "left": oGuide.oOverlayCurrent.nLeft,
                    "top": oGuide.oOverlayCurrent.nTop,
                    "width": oGuide.oOverlayCurrent.nWidth,
                    "height": oGuide.oOverlayCurrent.nHeight
                });
            } else {
                $("div#divOverlay").css("display", "none");
                $("iframe#iframeOverlay").attr("src", "Loading.html");
                $("object#object" + oGuide.sType + "-" + oGuide.sMedia + "-" + oGuide.nProject).focus();
            }

            return true;
        }
    };

    nScaling = (oGuide.oApplicationNative.nHeight * oGuide.oDocument.nWidth > oGuide.oApplicationNative.nWidth * oGuide.oDocument.nHeight)
        ? oGuide.oDocument.nHeight / oGuide.oApplicationNative.nHeight
        : oGuide.oDocument.nWidth / oGuide.oApplicationNative.nWidth;
    nScaling = (Math.abs(nScaling - 1 / 1) < 1 / 100)
        ? 1
        : nScaling;
    nScaling = (Math.abs(nScaling - 1 / 2) < 2 / 100)
        ? 1 / 2
        : nScaling;
    nScaling = (Math.abs(nScaling - 1 / 4) < 4 / 100)
        ? 1 / 4
        : nScaling;
    //if (nScaling === 1) window.alert("Native");

    oGuide.oApplicationCurrent = {
        "nWidth": Math.floor(nScaling * oGuide.oApplicationNative.nWidth),
        "nHeight": Math.floor(nScaling * oGuide.oApplicationNative.nHeight)
    };
    oGuide.oOverlayCurrent = {
        "nLeft": Math.floor(nScaling * oGuide.oOverlayNative.nLeft),
        "nTop": Math.floor(nScaling * oGuide.oOverlayNative.nTop),
        "nWidth": Math.floor(nScaling * oGuide.oOverlayNative.nWidth),
        "nHeight": Math.floor(nScaling * oGuide.oOverlayNative.nHeight)
    };

    $("div#divViewport").add("div#divGuide").css({"width": oGuide.oApplicationCurrent.nWidth, "height": oGuide.oApplicationCurrent.nHeight});
    $("div#divOverlay").css({"width": oGuide.oOverlayCurrent.nWidth, "height": oGuide.oOverlayCurrent.nHeight, "left": oGuide.oOverlayCurrent.nLeft, "top": oGuide.oOverlayCurrent.nTop});

    var oFlashVars = {
        "settings": "res-" + oGuide.nProject + "/Guide3D-Application-" + oGuide.nProject + ".xml"
    };
    var oFlashParameters = {
        "menu": "false",
        "quality": "high",
        "scale": "showall",
        "bgcolor": "#000000",
        "wmode": "direct",
        "salign": "t",
        "allowfullscreen": "true",
        "allowfullscreeninteractive" : "true",
        "allowscriptaccess": "sameDomain"
    };
    var oFlashAttributes = {
        "id": "object" + oGuide.sType + "-" + oGuide.sMedia + "-" + oGuide.nProject,
        "name": "object" + oGuide.sType + "-" + oGuide.sMedia + "-" + oGuide.nProject,
        "align": "top",
        "style": "touch-action:none;"
    };
    var fFlashCallback = function (oEvent) {
        if (oEvent.success) {
            oGuide.element = oEvent.ref;
            oGuide.element.tabIndex = 0;
            oGuide.element.focus();
        }
    };
    swfobject.embedSWF(oGuide.sType + "-" + oGuide.sMedia + "-" + "generic-mall" + ".swf" + "?" + Math.floor(Math.random() * 10000), "divGuide", oGuide.oApplicationCurrent.nWidth, oGuide.oApplicationCurrent.nHeight, "10.0.0", "swf/ExpressInstall.swf", oFlashVars, oFlashParameters, oFlashAttributes, fFlashCallback);

    //window.setTimeout(oGuide.displayOverlay, 3000);

    /*
    window.addEventListener("touchstart", function (oEvent) {
        "use strict";
        if (oEvent.touches.length > 1) {  // prevents only multi-touch events such as pinch on Chromium browsers
            oEvent.preventDefault();
        }
    }, false);

    $(window).on("resize", function () {
        window.location.href = window.location.href;
    });

    if (/logging=true/i.test(window.location.search)) {
        $(window).on("beforeunload", function (oEvent) {
            $.noop(oEvent);
            //oEvent.returnValue = "\o/";
            //return "\o/";
            oGuide.element.logShutdown();
            return void(0);
        });
    }
    */

});
